import $ from "jquery";
import Vue from 'vue'
import App from './App.vue'
import router from './router'  // 引入定义好的router
import ElementUI from 'element-ui';
import 'element-ui/lib/theme-chalk/index.css';
import VXETable from 'vxe-table'
import 'vxe-table/lib/style.css'

Vue.use(VXETable)
Vue.use(ElementUI);

// import ToolKit from "./views/index.vue";




let toolkit
let timer;
//生成Toolkit
function generateToolkit() {
    // global.app = new Vue(ToolKit);
    let h = $(".tooldrag").height();
    // console.log(h)
    let difference = 26 - h; //获得高度值差
    if (difference > 0) {
        $(".tooldrag").css("cssText", "height:" + (26 + difference) + "px!important")
    }
    //实现提示框拖拽功能
    $('.tooldrag').mousedown(function (e) {
        // e.pageX
        var positionDiv = $(this).offset();
        var distanceX = e.pageX - positionDiv.left;
        var distanceY = e.pageY - positionDiv.top;
        $(document).mousemove(function (e) {
            var x = e.clientX - distanceX;
            var y = e.clientY - distanceY;

            if (x < 0) {
                x = 0;
            } else if (x > window.innerWidth - $('.tooldrag').outerWidth(true)) {
                x = window.innerWidth - $('.tooldrag').outerWidth(true);
            }

            if (y < 0) {
                y = 0;
            } else if (y > window.innerHeight - $('.tooldrag').outerHeight(true)) {
                y = window.innerHeight - $('.tooldrag').outerHeight(true);
            }

            $('.tooltips').css({
                'right': window.innerWidth - x - $('.tooltips').outerWidth(true) + 'px',
                'bottom': window.innerHeight - y - $('.tooltips').outerHeight(true) + 'px',
            });
        });

        $(document).mouseup(function () {
            $(document).off('mousemove');
        });
    });
    // 拖拽右下角改变大小
    const wrapperToolkit = document.getElementById('wrapperToolkit');
    const KiviiWebTool = document.getElementById('KiviiWebTool');
    // console.log(KiviiWebTool)
    let mousedown = false;
    let startX, startY, startWidth, startHeight;


    KiviiWebTool.addEventListener('mousedown', e => {
        mousedown = true;
        startX = e.clientX;
        startY = e.clientY;
        startWidth = wrapperToolkit.offsetWidth;
        startHeight = wrapperToolkit.offsetHeight;
        e.preventDefault();
    });

    window.addEventListener('mousemove', e => {
        // if the mouse is not pressed, do nothing
        if (!mousedown) return;
        let newX = e.clientX;
        let newY = e.clientY;

        // Update the width: Original width - (current mouse X position - original mouse X position)
        let newWidth = startWidth - (newX - startX);

        // Update the height: Original height - (current mouse Y position - original mouse Y position)
        let newHeight = startHeight - (newY - startY);
        if (newWidth > 300 && newWidth < 1200) {
            wrapperToolkit.style.width = `${newWidth}px`;
        }
        if (newHeight > 420 && newHeight < 800) {
            wrapperToolkit.style.height = `${newHeight}px`;
            // console.log(newHeight)
            try {
                let toolkitcontain = document.getElementsByClassName('toolkitcontain')[0];
                toolkitcontain.style.height = `${newHeight - 330}px`;
            } catch (e) {

            }
        }
    });

    window.addEventListener('mouseup', e => {
        // when the mouse is released, stop resizing
        mousedown = false;
    });
    timer = setInterval(function () { //时刻监测相应元素是否存在(防止出现如百度一样元素消失重写body的情况)，如果不存在，添加进来
        if (document.body != null && document.getElementsByClassName("tooltips").length == 0) {
            this.clearInterval(); //先取消原来的计时器，再设置新的计时器
            document.body.append(toolkit);
            generateToolkit();
        }
    }, 3000);
}

// window.onload = function () {

let mousemovebind = false; //如果出现元素默认绑定了mousemove事件导致匹配不到元素的时候，开启第二种模式获得元素

toolkit = document.createElement("div");
toolkit.classList = "tooltips"; //添加样式
toolkit.setAttribute("id", "wrapperToolkit");
let tooltips = false; //标记鼠标是否在提示框上

//右键菜单屏蔽
document.oncontextmenu = () => false;

toolkit.addEventListener("mousedown", function (e) { e.stopPropagation(); }); //重新定义toolkit里的点击事件

document.body.append(toolkit);
console.log(document)

$(".tooltips").html(`
<div id="k5WebDriver"></div>
`);
// global.app = new Vue(ToolKit);
new Vue({
    el: '#k5WebDriver',
    router,
    render: h => h(App)
})

document.addEventListener("DOMContentLoaded", function () {
    // 在 DOMContentLoaded 事件触发后执行的代码
    var body = document.body;

    // 执行其他操作
});
generateToolkit();
// }

