

// 返回table数据   传入选择的xpaths
function getTableData (Xpaths) {
    console.log('这是table界面')
    // 最后返回结果
    let foundElements = []
    let transformedData = []
    let commonPathResults = processXPaths(Xpaths)
    // 找出相同的path
    let sameXpath = commonPathResults.commonRoot
    let subTagets = commonPathResults.processedPaths
    // 先拼接xpath 根据xpath判断网页中是否有该元素，从最后一位向上找
    let resultElement = combineXPaths(sameXpath, subTagets);
    // 判断是否有数据
    if (resultElement) {
        console.log("Element found: ", resultElement);
        // 将页面过滤出来的元素的xpath进行元素查找，并且返回元素的xpath和内容
        foundElements = findElements(resultElement);
        console.log(foundElements);
        // 返回表格需要的格式
        transformedData = foundElements.map((group, index) => {
            let transformedGroup = {};
            group.elements.forEach((element, elemIndex) => {
                transformedGroup[`content${elemIndex}`] = {
                    Xpath: element.xpath,
                    content: element.content,
                    otherName: "请填写标题"
                };
            });

            transformedGroup["_X_ROW_KEY"] = `row_${index + 0}`; // 假设起始索引为8

            return transformedGroup;
        });
        return transformedData

    } else {
        console.log("Element not found");
        return null
    }


}
//获取相同的xpath路径,并将原始数组公共部分去除，公共部分根节点最后一位下标去除
function processXPaths (paths) {
    if (!paths || paths.length === 0) {
        return { commonRoot: '', processedPaths: [] };
    }

    // 分割每个路径为组成部分
    let splitPaths = paths.map(path => path.split('/'));

    // 查找公共前缀
    let commonPath = [];
    for (let i = 0; i < splitPaths[0].length; i++) {
        let currentPart = splitPaths[0][i];

        // 检查所有路径是否有这个部分
        if (splitPaths.every(path => path[i] === currentPart)) {
            commonPath.push(currentPart);
        } else {
            break;
        }
    }

    // 将公共部分转换为字符串
    let commonPathStr = commonPath.join('/');

    // 先去除每个路径中的公共部分
    let pathsWithoutCommon = paths.map(path => path.replace(commonPathStr, '').replace(/^\/+/, ''));

    // 然后去除公共路径最后一个元素的下标
    if (commonPath.length > 0) {
        let lastElement = commonPath[commonPath.length - 1];
        let lastElementWithoutIndex = lastElement.split('[')[0];
        commonPath[commonPath.length - 1] = lastElementWithoutIndex;
    }

    // 更新公共根节点路径，去除最后一个元素的下标
    let updatedCommonPathStr = commonPath.join('/');

    return { commonRoot: updatedCommonPathStr, processedPaths: pathsWithoutCommon };
}
// 公共部分与拆解部分组合查询
function combineXPaths (commonXPath, paths) {
    let content = [];
    let index = 0;

    // 从给定的XPath中去除最后一个节点
    function removeLastNode (xpath) {
        let parts = xpath.split('/');
        parts.pop();
        return parts.join('/');
    }

    // 检查XPath是否指向一个存在的元素
    function elementExists (xpath) {
        let result = document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
        return !!result.singleNodeValue;
    }

    while (true) {
        let indexedCommonXPath = commonXPath + '[' + (index + 1) + ']'; // XPath的下标从1开始

        // 如果当前下标的元素不存在，则向上查找
        while (!elementExists(indexedCommonXPath) && indexedCommonXPath.length > commonXPath.length) {
            indexedCommonXPath = removeLastNode(indexedCommonXPath);
        }

        // 如果找到公共XPath层，则停止查找
        if (indexedCommonXPath.length <= commonXPath.length) {
            break;
        }

        // 将找到的XPath与路径组合，并存储在content数组中
        let combinedPaths = paths.map(path => indexedCommonXPath + '/' + path);
        content.push({ index: index, paths: combinedPaths });

        index++;
    }

    return content;
}
// 找element
function findElements (arrayObjects) {
    let results = [];

    // 从给定的XPath中去除最后一个节点
    function removeLastNode (xpath) {
        let parts = xpath.split('/');
        parts.pop();
        return parts.join('/');
    }

    // 检查XPath是否指向一个存在的元素
    function elementExists (xpath) {
        let result = document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
        return !!result.singleNodeValue;
    }

    // 对每个paths数组进行查找
    arrayObjects.forEach(item => {
        let groupResult = { index: item.index, elements: [] };

        item.paths.forEach(path => {
            let currentXPath = path;

            // 从XPath的最后一个节点开始查找
            while (!elementExists(currentXPath) && currentXPath !== '') {
                currentXPath = removeLastNode(currentXPath);
            }

            // 如果找到了元素
            if (currentXPath !== '') {
                let result = document.evaluate(currentXPath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
                let element = result.singleNodeValue;
                groupResult.elements.push({ xpath: currentXPath, content: element.textContent });
            }
        });

        results.push(groupResult);
    });

    return results;
}

export { getTableData }